/*
 * Copyright (C) 2003 Mads Martin Joergensen <mmj at mmj.dk>
 * Copyright (C) 2023 Baptiste Daroussin <bapt@FreeBSD.org>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#include <sys/stat.h>
#include <unistd.h>

#include "mlmmj.h"
#include "send_help.h"
#include "utils.h"
#include "xmalloc.h"
#include "send_mail.h"

void
send_help_noexit(struct ml *ml, const char *queuefilename, const char *emailaddr)
{
	char *fromaddr;
	struct mail mail = { 0 };

	gen_addr(fromaddr, ml, "bounces-help");

	mail.to = emailaddr;
	mail.from = fromaddr;
	mail.fp = fopen(queuefilename, "r");
	if (!send_single_mail(&mail, ml, false))
		save_queue(queuefilename, &mail);
	else
		unlink(queuefilename);
	if (mail.fp)
		fclose(mail.fp);
}

void
send_help(struct ml *ml, const char *queuefilename, const char *emailaddr)
{
	send_help_noexit(ml, queuefilename, emailaddr);
	exit(EXIT_SUCCESS);
}
